/* sf62r.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int sf62r_c(integer *nn, real *xx, real *enx, real *expenx)
{
    /* Initialized data */

    static real two = 2.f;
    static real ulps = 1.f;
    static real zero = 0.f;
    static real sys059 = 3.4e38f;
    static real sys056 = 1.175495e-38f; /* = sys055 */
    static real sys051 = 1.192093e-7f;
    static real sys053 = 3.4e38f;
    static real half = .5f;
    static real one = 1.f;
    static struct {
        real e_1;
        } equiv_0 = { .5772157f };

    /* Builtin functions */
    double exp(doublereal), log(doublereal);

    /* Local variables */
    static real asum, temp, xlog, prev, d__, f;
#define sys039 ((real *)&equiv_0)
    static integer n;
    static real r__, x;
#define euler ((real *)&equiv_0)
    static real pterm, expnx, am, bm, fm, gm, rm, rn, tm, psi, sum, fmm1, 
            fmm2, gmm2, gmm1, rnm1;

    x = *xx;
    n = *nn;
    if (x < zero) {
        x = abs(x);
    }
    if (n < 0) {
        n = abs(n);
    }
    rn = (real) n;
    if (x == zero) {
        goto L1;
    }
    expnx = (real)exp((real)(-x));
    xlog = (real)log(x);
    if (n != 0) {
        goto L4;
    }
    if (x <= sys056) {
        goto L2;
    }
    *expenx = one / x;
    *enx = expnx * *expenx;
    goto L20;
L1:
    if (n <= 1) {
        goto L2;
    }
    *enx = one / (rn - one);
    goto L3;
L2:
    *enx = sys059;
L3:
    *expenx = *enx;
    goto L20;
L4:
    if (x <= ulps) {
        goto L5;
    }
    if (x <= sys059 - rn) {
        goto L13;
    }
    *expenx = zero;
    *enx = *expenx;
    goto L20;
L5:
    rm = 0.f;
    pterm = -one;
    sum = 0.f;
    psi = -(*euler);
    d__ = -(rn - one);
L6:
    if (d__ >= half) {
        goto L8;
    }
    if (-d__ >= half) {
        goto L7;
    }
    sum = pterm * (xlog - psi) + sum;
    goto L12;
L7:
    psi += one / (rm + one);
L8:
    tm = pterm / d__;
    sum = tm + sum;
    if (sum < zero) {
        goto L9;
    }
    asum = sum;
    goto L10;
L9:
    asum = -sum;
L10:
    if (asum != 0.f) {
        goto L11;
    } else {
        goto L12;
    }
L11:
    if (tm < zero) {
        tm = -tm;
    }
    if (tm / asum > sys051) {
        goto L12;
    }
    *enx = sum;
    *expenx = *enx / expnx;
    goto L20;
L12:
    rm += one;
    d__ += one;
    pterm = -(x * pterm) / rm;
    goto L6;
L13:
    rm = one;
    fmm2 = one;
    gmm2 = 0.f;
    fmm1 = 0.f;
    gmm1 = one;
    prev = fmm1 / gmm1;
    am = one;
    bm = x + rn;
    rnm1 = rn - one;
L14:
    fm = bm * fmm1 + am * fmm2;
    gm = bm * gmm1 + am * gmm2;
    f = fm / gm;
    temp = one - prev / f;
    if (temp > zero) {
        goto L15;
    }
    *expenx = prev;
    goto L16;
L15:
    if (temp > sys051) {
        goto L17;
    }
    *expenx = f;
L16:
    *enx = expnx * *expenx;
    goto L20;
L17:
    if (gm < sys053 / bm) {
        goto L18;
    }
    fmm1 /= bm;
    gmm1 /= bm;
    fm /= bm;
    gm /= bm;
    goto L19;
L18:
    if (gm < sys053 / abs(am)) {
        goto L19;
    }
    r__ = abs(am);
    fmm1 /= r__;
    gmm1 /= r__;
    fm /= r__;
    gm /= r__;
L19:
    am = -rm * (rnm1 + rm);
    rm += one;
    bm += two;
    fmm2 = fmm1;
    gmm2 = gmm1;
    fmm1 = fm;
    gmm1 = gm;
    prev = f;
    goto L14;
L20:
    return 0;
} /* sf62r_c */

#undef euler
#undef sys039
